/*
 *	Rule 83:	Required
 *			
 *	For functions with non-void return type:
 *		i) 	there shall be one return statement for every exit
 *			branch (including the end of the program),
 *		ii)	each return shall have an expression,
 *		iii)	the return expression shall match the declared return
 *			type.
*/ 

// NOTE that for this to work YOU must have -C enabled,  so that op_return [ op_base(1) ] works correctly.

#include "misra.cch"

int curFbase;

if ( dcl_function ) {

	curFbase = dcl_base_root;
}

if ( stm_return_void ) {

	if ( curFbase != VOID_TYPE ) {

		WARN_MR( 83, "16.8 Non void return type must be explicit expression. { RET VOID }" );
	}


}

if ( op_return ) {
	if ( op_base(1) != curFbase ) {
	
		WARN_MR( 83, "16.8 Non Void return type must match. { RET MISMATCH }" );
	}
}